'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = create;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _constants = require('../util/constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function create(styles) {
  var Button = function (_Component) {
    (0, _inherits3.default)(Button, _Component);

    function Button() {
      (0, _classCallCheck3.default)(this, Button);
      return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Button).apply(this, arguments));
    }

    (0, _createClass3.default)(Button, [{
      key: 'render',
      value: function render() {
        var _cx;

        var _props = this.props;
        var className = _props.className;
        var color = _props.color;
        var disabled = _props.disabled;
        var dropdown = _props.dropdown;
        var dropdownArrowOnly = _props.dropdownArrowOnly;
        var expanded = _props.expanded;
        var hollow = _props.hollow;
        var href = _props.href;
        var size = _props.size;
        var target = _props.target;

        var classNames = (0, _classnames2.default)(className, styles.button, (_cx = {}, (0, _defineProperty3.default)(_cx, styles[color], _constants.COMPONENT_COLORS.includes(color)), (0, _defineProperty3.default)(_cx, styles.disabled, disabled), (0, _defineProperty3.default)(_cx, styles.dropdown, dropdown), (0, _defineProperty3.default)(_cx, styles['arrow-only'], dropdown && dropdownArrowOnly), (0, _defineProperty3.default)(_cx, styles.expanded, expanded), (0, _defineProperty3.default)(_cx, styles.hollow, hollow), (0, _defineProperty3.default)(_cx, styles[size], _constants.COMPONENT_SIZES.includes(size)), _cx));

        if (href || target) {
          return _react2.default.createElement('a', (0, _extends3.default)({}, this.props, {
            'aria-disabled': disabled,
            className: classNames,
            href: href || '#',
            role: 'button'
          }));
        }

        return _react2.default.createElement('button', (0, _extends3.default)({}, this.props, { className: classNames }));
      }
    }]);
    return Button;
  }(_react.Component);

  Button.propTypes = {
    className: _react.PropTypes.string,
    color: _react.PropTypes.oneOf(_constants.COMPONENT_COLORS),
    disabled: _react.PropTypes.bool,
    dropdown: _react.PropTypes.bool,
    dropdownArrowOnly: _react.PropTypes.bool,
    expanded: _react.PropTypes.bool,
    hollow: _react.PropTypes.bool,
    href: _react.PropTypes.string,
    size: _react.PropTypes.oneOf(_constants.COMPONENT_SIZES),
    target: _react.PropTypes.string,
    type: _react.PropTypes.oneOf(['button', 'reset', 'submit'])
  };
  Button.defaultProps = {
    type: 'button'
  };


  return { Button: Button };
}