'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = create;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _isBlank = require('underscore.string/isBlank');

var _isBlank2 = _interopRequireDefault(_isBlank);

var _constants = require('../util/constants');

var _createHigherOrderComponent = require('../util/create-higher-order-component');

var _createHigherOrderComponent2 = _interopRequireDefault(_createHigherOrderComponent);

var _overlayTrigger = require('../util/overlay-trigger');

var _overlayTrigger2 = _interopRequireDefault(_overlayTrigger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function create(styles, Transition) {
  var Dropdown = function (_Component) {
    (0, _inherits3.default)(Dropdown, _Component);

    function Dropdown() {
      (0, _classCallCheck3.default)(this, Dropdown);
      return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Dropdown).apply(this, arguments));
    }

    (0, _createClass3.default)(Dropdown, [{
      key: 'render',
      value: function render() {
        var _cx;

        var _props = this.props;
        var className = _props.className;
        var position = _props.position;
        var size = _props.size;

        var classNames = (0, _classnames2.default)(className, styles['dropdown-pane'], styles['is-open'], (_cx = {}, (0, _defineProperty3.default)(_cx, styles[position], _constants.OVERLAY_POSITIONS_INTERNAL.includes(position)), (0, _defineProperty3.default)(_cx, styles[size], _constants.COMPONENT_SIZES.includes(size)), _cx));

        return _react2.default.createElement('div', (0, _extends3.default)({}, this.props, { className: classNames }));
      }
    }]);
    return Dropdown;
  }(_react.Component);

  Dropdown.propTypes = {
    className: _react.PropTypes.string,
    position: _react.PropTypes.oneOf(_constants.OVERLAY_POSITIONS),
    size: _react.PropTypes.oneOf(_constants.COMPONENT_SIZES)
  };
  Dropdown.defaultProps = {
    position: 'bottom'
  };


  var HasDropdown = (0, _createHigherOrderComponent2.default)({
    displayName: 'HasDropdown',
    mapPropsToProps: function mapPropsToProps(_ref) {
      var dropdownId = _ref.dropdownId;
      var restProps = (0, _objectWithoutProperties3.default)(_ref, ['dropdownId']);

      var props = (0, _extends3.default)({}, restProps, {
        'aria-haspopup': true
      });

      if (!(0, _isBlank2.default)(dropdownId)) {
        props['aria-controls'] = dropdownId;
      }

      return props;
    }
  });

  var LinkWithDropdown = function (_Component2) {
    (0, _inherits3.default)(LinkWithDropdown, _Component2);

    function LinkWithDropdown() {
      (0, _classCallCheck3.default)(this, LinkWithDropdown);
      return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(LinkWithDropdown).apply(this, arguments));
    }

    (0, _createClass3.default)(LinkWithDropdown, [{
      key: 'render',
      value: function render() {
        var _props2 = this.props;
        var children = _props2.children;
        var dropdownClassName = _props2.dropdownClassName;
        var dropdownContent = _props2.dropdownContent;
        var dropdownId = _props2.dropdownId;
        var dropdownPosition = _props2.dropdownPosition;
        var dropdownSize = _props2.dropdownSize;
        var dropdownStyle = _props2.dropdownStyle;

        var labelledBy = null;

        if ((0, _react.isValidElement)(children) && !(0, _isBlank2.default)(children.props.id)) {
          labelledBy = children.props.id;
        }

        var dropdown = _react2.default.createElement(
          Dropdown,
          {
            'aria-labelledby': labelledBy,
            className: dropdownClassName,
            id: dropdownId,
            position: dropdownPosition,
            size: dropdownSize,
            style: dropdownStyle
          },
          dropdownContent
        );

        return _react2.default.createElement(
          _overlayTrigger2.default,
          (0, _extends3.default)({}, this.props, { overlay: dropdown, position: dropdownPosition }),
          _react2.default.createElement(
            HasDropdown,
            this.props,
            children
          )
        );
      }
    }]);
    return LinkWithDropdown;
  }(_react.Component);

  LinkWithDropdown.propTypes = {
    children: _react.PropTypes.node,
    dropdownClassName: _react.PropTypes.string,
    dropdownContent: _react.PropTypes.node,
    dropdownId: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),
    dropdownPosition: _react.PropTypes.oneOf(_constants.OVERLAY_POSITIONS),
    dropdownSize: _react.PropTypes.oneOf(_constants.COMPONENT_SIZES),
    dropdownStyle: _react.PropTypes.object
  };
  LinkWithDropdown.defaultProps = {
    dropdownPosition: 'bottom',
    transition: Transition,
    triggerClick: true
  };


  return { Dropdown: Dropdown, HasDropdown: HasDropdown, LinkWithDropdown: LinkWithDropdown };
}