'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

exports.default = create;

var _react = require('react');

var _constants = require('../util/constants');

var _createHigherOrderComponent = require('../util/create-higher-order-component');

var _createHigherOrderComponent2 = _interopRequireDefault(_createHigherOrderComponent);

var _screenSize = require('../util/screen-size');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var childPropTypes = (0, _screenSize.createScreenSizePropTypes)(_constants.FLEX_CHILD_CLASS_NAMES);

function create(styles) {
  var Parent = (0, _createHigherOrderComponent2.default)({
    displayName: 'FlexParent',
    propTypes: {
      horizontalAlignment: _react.PropTypes.oneOf(_constants.FLEX_HORIZONTAL_ALIGNMENTS),
      verticalAlignment: _react.PropTypes.oneOf(_constants.FLEX_VERTICAL_ALIGNMENTS)
    },
    mapPropsToClassNames: function mapPropsToClassNames(_ref) {
      var _ref2;

      var horizontalAlignment = _ref.horizontalAlignment;
      var verticalAlignment = _ref.verticalAlignment;
      return _ref2 = {}, (0, _defineProperty3.default)(_ref2, styles['align-' + horizontalAlignment], _constants.FLEX_HORIZONTAL_ALIGNMENTS_INTERNAL.includes(horizontalAlignment)), (0, _defineProperty3.default)(_ref2, styles['align-' + verticalAlignment], _constants.FLEX_VERTICAL_ALIGNMENTS.includes(verticalAlignment)), _ref2;
    },
    defaultComponentClass: 'div'
  });

  var Child = (0, _createHigherOrderComponent2.default)({
    displayName: 'FlexChild',
    propTypes: (0, _extends3.default)({}, childPropTypes, {
      verticalAlignment: _react.PropTypes.oneOf(_constants.FLEX_VERTICAL_ALIGNMENTS)
    }),
    mapPropsToClassNames: function mapPropsToClassNames(_ref3) {
      var verticalAlignment = _ref3.verticalAlignment;
      var props = (0, _objectWithoutProperties3.default)(_ref3, ['verticalAlignment']);

      var classNames = (0, _screenSize.createScreenSizeClassNamesFromProps)(_constants.FLEX_CHILD_CLASS_NAMES, props, styles);

      classNames[styles['align-self-' + verticalAlignment]] = _constants.FLEX_VERTICAL_ALIGNMENTS.includes(verticalAlignment);

      return classNames;
    },
    defaultComponentClass: 'div'
  });

  return { Parent: Parent, Child: Child };
}