'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = create;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _constants = require('../../util/constants');

var _screenSize = require('../../util/screen-size');

var _defaultComponent = require('../../util/default-component');

var _defaultComponent2 = _interopRequireDefault(_defaultComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var rowPropTypes = (0, _screenSize.createScreenSizePropTypes)(_constants.FLEX_GRID_ROW_CLASS_NAMES);
rowPropTypes.className = _react.PropTypes.string;
rowPropTypes.collapse = _react.PropTypes.bool;
rowPropTypes.expanded = _react.PropTypes.bool;

var columnPropTypes = (0, _screenSize.createScreenSizePropTypes)(_constants.FLEX_GRID_COLUMN_CLASS_NAMES);
columnPropTypes.className = _react.PropTypes.string;
columnPropTypes.shrink = _react.PropTypes.bool;

function create(styles) {
  var FlexParent = arguments.length <= 1 || arguments[1] === undefined ? _defaultComponent2.default : arguments[1];
  var FlexChild = arguments.length <= 2 || arguments[2] === undefined ? _defaultComponent2.default : arguments[2];

  var Row = function (_Component) {
    (0, _inherits3.default)(Row, _Component);

    function Row() {
      (0, _classCallCheck3.default)(this, Row);
      return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Row).apply(this, arguments));
    }

    (0, _createClass3.default)(Row, [{
      key: 'render',
      value: function render() {
        var _cx;

        var _props = this.props;
        var className = _props.className;
        var collapse = _props.collapse;
        var expanded = _props.expanded;

        var classNames = (0, _classnames2.default)(className, styles.row, (0, _screenSize.createScreenSizeClassNamesFromProps)(_constants.FLEX_GRID_ROW_CLASS_NAMES, this.props, styles), (_cx = {}, (0, _defineProperty3.default)(_cx, styles.collapse, collapse), (0, _defineProperty3.default)(_cx, styles.expanded, expanded), _cx));

        return _react2.default.createElement(FlexParent, (0, _extends3.default)({}, this.props, { className: classNames, componentClass: 'div' }));
      }
    }]);
    return Row;
  }(_react.Component);

  Row.propTypes = rowPropTypes;

  var Column = function (_Component2) {
    (0, _inherits3.default)(Column, _Component2);

    function Column() {
      (0, _classCallCheck3.default)(this, Column);
      return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Column).apply(this, arguments));
    }

    (0, _createClass3.default)(Column, [{
      key: 'render',
      value: function render() {
        var _props2 = this.props;
        var className = _props2.className;
        var shrink = _props2.shrink;

        var classNames = (0, _classnames2.default)(className, styles.column, (0, _screenSize.createScreenSizeClassNamesFromProps)(_constants.FLEX_GRID_COLUMN_CLASS_NAMES, this.props, styles), (0, _defineProperty3.default)({}, styles.shrink, shrink));

        return _react2.default.createElement(FlexChild, (0, _extends3.default)({}, this.props, { className: classNames }));
      }
    }]);
    return Column;
  }(_react.Component);

  Column.propTypes = columnPropTypes;


  return { Row: Row, Column: Column };
}