'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = create;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _constants = require('../util/constants');

var _defaultComponent = require('../util/default-component');

var _defaultComponent2 = _interopRequireDefault(_defaultComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function create(styles) {
  var FlexParent = arguments.length <= 1 || arguments[1] === undefined ? _defaultComponent2.default : arguments[1];
  var FlexChild = arguments.length <= 2 || arguments[2] === undefined ? _defaultComponent2.default : arguments[2];

  var MediaObjectSection = function (_Component) {
    (0, _inherits3.default)(MediaObjectSection, _Component);

    function MediaObjectSection() {
      (0, _classCallCheck3.default)(this, MediaObjectSection);
      return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(MediaObjectSection).apply(this, arguments));
    }

    (0, _createClass3.default)(MediaObjectSection, [{
      key: 'render',
      value: function render() {
        var _cx;

        var _props = this.props;
        var alignment = _props.alignment;
        var className = _props.className;
        var main = _props.main;
        var verticalAlignment = _props.verticalAlignment;

        var classNames = (0, _classnames2.default)(className, styles['media-object-section'], (_cx = {}, (0, _defineProperty3.default)(_cx, styles[alignment], styles[alignment] && _constants.MEDIA_OBJECT_SECTION_ALIGNMENTS.includes(alignment)), (0, _defineProperty3.default)(_cx, styles['main-section'], styles['main-section'] && main), _cx));

        return _react2.default.createElement(FlexChild, (0, _extends3.default)({}, this.props, {
          className: classNames,
          componentClass: 'div',
          verticalAlignment: verticalAlignment || alignment
        }));
      }
    }]);
    return MediaObjectSection;
  }(_react.Component);

  MediaObjectSection.propTypes = {
    alignment: _react.PropTypes.oneOf(_constants.MEDIA_OBJECT_SECTION_ALIGNMENTS),
    className: _react.PropTypes.string,
    main: _react.PropTypes.bool,
    verticalAlignment: _react.PropTypes.oneOf(_constants.FLEX_VERTICAL_ALIGNMENTS)
  };

  var MediaObject = function (_Component2) {
    (0, _inherits3.default)(MediaObject, _Component2);

    function MediaObject() {
      (0, _classCallCheck3.default)(this, MediaObject);
      return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(MediaObject).apply(this, arguments));
    }

    (0, _createClass3.default)(MediaObject, [{
      key: 'render',
      value: function render() {
        var _props2 = this.props;
        var className = _props2.className;
        var stackForSmall = _props2.stackForSmall;

        var classNames = (0, _classnames2.default)(className, styles['media-object'], (0, _defineProperty3.default)({}, styles['stack-for-small'], stackForSmall));

        return _react2.default.createElement(FlexParent, (0, _extends3.default)({}, this.props, { className: classNames, componentClass: 'div' }));
      }
    }]);
    return MediaObject;
  }(_react.Component);

  MediaObject.propTypes = {
    className: _react.PropTypes.string,
    stackForSmall: _react.PropTypes.bool
  };


  return { MediaObject: MediaObject, MediaObjectSection: MediaObjectSection };
}