'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = create;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _constants = require('../util/constants');

var _defaultComponent = require('../util/default-component');

var _defaultComponent2 = _interopRequireDefault(_defaultComponent);

var _createHigherOrderComponent = require('../util/create-higher-order-component');

var _createHigherOrderComponent2 = _interopRequireDefault(_createHigherOrderComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function create(styles) {
  var FlexParent = arguments.length <= 1 || arguments[1] === undefined ? _defaultComponent2.default : arguments[1];
  var FlexChild = arguments.length <= 2 || arguments[2] === undefined ? _defaultComponent2.default : arguments[2];

  var Menu = function (_Component) {
    (0, _inherits3.default)(Menu, _Component);

    function Menu() {
      (0, _classCallCheck3.default)(this, Menu);
      return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Menu).apply(this, arguments));
    }

    (0, _createClass3.default)(Menu, [{
      key: 'render',
      value: function render() {
        var _cx;

        var _props = this.props;
        var alignment = _props.alignment;
        var centerContainerClassName = _props.centerContainerClassName;
        var centerContainerStyle = _props.centerContainerStyle;
        var className = _props.className;
        var expanded = _props.expanded;
        var horizontal = _props.horizontal;
        var horizontalAlignment = _props.horizontalAlignment;
        var iconTop = _props.iconTop;
        var nested = _props.nested;
        var simple = _props.simple;
        var vertical = _props.vertical;

        var classNames = (0, _classnames2.default)(className, styles.menu, (_cx = {}, (0, _defineProperty3.default)(_cx, styles['align-' + alignment], styles['align-' + alignment] && alignment !== _constants.CENTER_POSITION && _constants.MENU_ALIGNMENTS.includes(alignment)), (0, _defineProperty3.default)(_cx, styles.expanded, expanded), (0, _defineProperty3.default)(_cx, styles.horizontal, horizontal && !_constants.LARGER_SCREEN_SIZES.includes(horizontal)), (0, _defineProperty3.default)(_cx, styles[horizontal + '-horizontal'], _constants.LARGER_SCREEN_SIZES.includes(horizontal)), (0, _defineProperty3.default)(_cx, styles['icon-top'], iconTop), (0, _defineProperty3.default)(_cx, styles.nested, nested), (0, _defineProperty3.default)(_cx, styles.simple, simple), (0, _defineProperty3.default)(_cx, styles.vertical, vertical && !_constants.LARGER_SCREEN_SIZES.includes(vertical)), (0, _defineProperty3.default)(_cx, styles[vertical + '-vertical'], _constants.LARGER_SCREEN_SIZES.includes(vertical)), _cx));

        var content = _react2.default.createElement(FlexParent, (0, _extends3.default)({}, this.props, {
          className: classNames,
          componentClass: 'ul',
          horizontalAlignment: horizontalAlignment || alignment
        }));

        if (alignment === _constants.CENTER_POSITION && styles['menu-centered']) {
          var centerContainerClassNames = (0, _classnames2.default)(centerContainerClassName, styles['menu-centered']);

          return _react2.default.createElement(
            'div',
            { className: centerContainerClassNames, style: centerContainerStyle },
            content
          );
        }

        return content;
      }
    }]);
    return Menu;
  }(_react.Component);

  Menu.propTypes = {
    alignment: _react.PropTypes.oneOf(_constants.MENU_ALIGNMENTS),
    centerContainerClassName: _react.PropTypes.string,
    centerContainerStyle: _react.PropTypes.object,
    className: _react.PropTypes.string,
    expanded: _react.PropTypes.bool,
    horizontal: _react.PropTypes.oneOfType([_react.PropTypes.bool, _react.PropTypes.oneOf(_constants.SCREEN_SIZES)]),
    horizontalAlignment: _react.PropTypes.oneOf(_constants.FLEX_HORIZONTAL_ALIGNMENTS),
    iconTop: _react.PropTypes.bool,
    nested: _react.PropTypes.bool,
    simple: _react.PropTypes.bool,
    vertical: _react.PropTypes.oneOfType([_react.PropTypes.bool, _react.PropTypes.oneOf(_constants.SCREEN_SIZES)])
  };


  var MenuText = (0, _createHigherOrderComponent2.default)({
    displayName: 'MenuText',
    mapPropsToClassNames: function mapPropsToClassNames() {
      return (0, _defineProperty3.default)({}, styles['menu-text'], true);
    }
  });

  var MenuItem = function (_Component2) {
    (0, _inherits3.default)(MenuItem, _Component2);

    function MenuItem() {
      (0, _classCallCheck3.default)(this, MenuItem);
      return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(MenuItem).apply(this, arguments));
    }

    (0, _createClass3.default)(MenuItem, [{
      key: 'render',
      value: function render() {
        var _props2 = this.props;
        var active = _props2.active;
        var className = _props2.className;
        var text = _props2.text;


        var classNames = (0, _classnames2.default)(className, (0, _defineProperty3.default)({}, styles.active, active));

        var content = _react2.default.createElement(FlexChild, (0, _extends3.default)({}, this.props, { className: classNames, componentClass: 'li' }));

        if (text) {
          return _react2.default.createElement(
            MenuText,
            null,
            content
          );
        }

        return content;
      }
    }]);
    return MenuItem;
  }(_react.Component);

  MenuItem.propTypes = {
    active: _react.PropTypes.bool,
    className: _react.PropTypes.string,
    text: _react.PropTypes.bool
  };


  return { Menu: Menu, MenuItem: MenuItem, MenuText: MenuText };
}