'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _defineProperty2 = require('babel-runtime/helpers/defineProperty');

var _defineProperty3 = _interopRequireDefault(_defineProperty2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.default = create;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _isBlank = require('underscore.string/isBlank');

var _isBlank2 = _interopRequireDefault(_isBlank);

var _constants = require('../util/constants');

var _createHigherOrderComponent = require('../util/create-higher-order-component');

var _createHigherOrderComponent2 = _interopRequireDefault(_createHigherOrderComponent);

var _overlayTrigger = require('../util/overlay-trigger');

var _overlayTrigger2 = _interopRequireDefault(_overlayTrigger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function create(styles, Transition) {
  var Tooltip = function (_Component) {
    (0, _inherits3.default)(Tooltip, _Component);

    function Tooltip() {
      (0, _classCallCheck3.default)(this, Tooltip);
      return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Tooltip).apply(this, arguments));
    }

    (0, _createClass3.default)(Tooltip, [{
      key: 'render',
      value: function render() {
        var _props = this.props;
        var className = _props.className;
        var position = _props.position;

        var classNames = (0, _classnames2.default)(className, styles.tooltip, (0, _defineProperty3.default)({}, styles[position], _constants.OVERLAY_POSITIONS_INTERNAL.includes(position)));

        return _react2.default.createElement('div', (0, _extends3.default)({}, this.props, { className: classNames, role: 'tooltip' }));
      }
    }]);
    return Tooltip;
  }(_react.Component);

  Tooltip.propTypes = {
    className: _react.PropTypes.string,
    position: _react.PropTypes.oneOf(_constants.OVERLAY_POSITIONS)
  };
  Tooltip.defaultProps = {
    position: 'bottom'
  };


  var HasTooltip = (0, _createHigherOrderComponent2.default)({
    displayName: 'HasTooltipBase',
    mapPropsToClassNames: function mapPropsToClassNames(_ref) {
      var tooltipIndicator = _ref.tooltipIndicator;
      return (0, _defineProperty3.default)({}, styles['has-tip'], tooltipIndicator);
    },
    mapPropsToProps: function mapPropsToProps(_ref3) {
      var tooltipId = _ref3.tooltipId;
      var restProps = (0, _objectWithoutProperties3.default)(_ref3, ['tooltipId']);

      var props = (0, _extends3.default)({}, restProps, {
        'aria-haspopup': true
      });

      if (!(0, _isBlank2.default)(tooltipId)) {
        props['aria-describedby'] = tooltipId;
      }

      return props;
    }
  });

  var LinkWithTooltip = function (_Component2) {
    (0, _inherits3.default)(LinkWithTooltip, _Component2);

    function LinkWithTooltip() {
      (0, _classCallCheck3.default)(this, LinkWithTooltip);
      return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(LinkWithTooltip).apply(this, arguments));
    }

    (0, _createClass3.default)(LinkWithTooltip, [{
      key: 'render',
      value: function render() {
        var _props2 = this.props;
        var children = _props2.children;
        var tooltipClassName = _props2.tooltipClassName;
        var tooltipContent = _props2.tooltipContent;
        var tooltipId = _props2.tooltipId;
        var tooltipPosition = _props2.tooltipPosition;
        var tooltipStyle = _props2.tooltipStyle;

        var tooltip = _react2.default.createElement(
          Tooltip,
          {
            className: tooltipClassName,
            id: tooltipId,
            position: tooltipPosition,
            style: tooltipStyle
          },
          tooltipContent
        );

        return _react2.default.createElement(
          _overlayTrigger2.default,
          (0, _extends3.default)({}, this.props, { overlay: tooltip, position: tooltipPosition }),
          _react2.default.createElement(
            HasTooltip,
            this.props,
            children
          )
        );
      }
    }]);
    return LinkWithTooltip;
  }(_react.Component);

  LinkWithTooltip.propTypes = {
    children: _react.PropTypes.node,
    tooltipClassName: _react.PropTypes.string,
    tooltipContent: _react.PropTypes.node,
    tooltipIndicator: _react.PropTypes.bool,
    tooltipId: _react.PropTypes.oneOfType([_react.PropTypes.string, _react.PropTypes.number]),
    tooltipPosition: _react.PropTypes.oneOf(_constants.OVERLAY_POSITIONS),
    tooltipStyle: _react.PropTypes.object
  };
  LinkWithTooltip.defaultProps = {
    closeOnClickOutside: true,
    tooltipIndicator: true,
    tooltipPosition: 'bottom',
    transition: Transition,
    triggerClick: true,
    triggerFocus: true,
    triggerHover: true
  };


  return { Tooltip: Tooltip, HasTooltip: HasTooltip, LinkWithTooltip: LinkWithTooltip };
}