'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FLEX_GRID_COLUMN_CLASS_NAMES = exports.FLEX_GRID_ROW_CLASS_NAMES = exports.FLEX_CHILD_CLASS_NAMES = exports.GRID_COLUMN_CLASS_NAMES = exports.GRID_ROW_CLASS_NAMES = exports.FLEX_VERTICAL_ALIGNMENTS = exports.MEDIA_OBJECT_SECTION_ALIGNMENTS = exports.FLEX_HORIZONTAL_ALIGNMENTS_INTERNAL = exports.FLEX_HORIZONTAL_ALIGNMENTS = exports.MENU_ALIGNMENTS = exports.TEXT_ALIGNMENTS = exports.FLOAT_POSITIONS = exports.OVERLAY_POSITIONS = exports.OVERLAY_POSITIONS_INTERNAL = exports.TOP_BAR_POSITIONS = exports.TITLE_BAR_POSITIONS = exports.OFF_CANVAS_POSITIONS = exports.CENTER_POSITION = exports.MODAL_SIZES = exports.COMPONENT_SIZES = exports.CALLOUT_SIZES = exports.COMPONENT_COLORS = exports.COMPONENT_ALTERNATIVE_COLORS = exports.SCREEN_ORIENTATIONS = exports.LARGER_SCREEN_SIZES = exports.SCREEN_SIZES = exports.SCREEN_SIZE_MEDIUM = exports.SCREEN_SIZE_SMALL = undefined;

var _toArray2 = require('babel-runtime/helpers/toArray');

var _toArray3 = _interopRequireDefault(_toArray2);

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SCREEN_SIZE_SMALL = exports.SCREEN_SIZE_SMALL = 'small';
var SCREEN_SIZE_MEDIUM = exports.SCREEN_SIZE_MEDIUM = 'medium';
var SCREEN_SIZES = exports.SCREEN_SIZES = [SCREEN_SIZE_SMALL, SCREEN_SIZE_MEDIUM, 'large', 'xlarge', 'xxlarge'];
var LARGER_SCREEN_SIZES = SCREEN_SIZES.slice(1);
exports.LARGER_SCREEN_SIZES = LARGER_SCREEN_SIZES;
var SCREEN_ORIENTATIONS = exports.SCREEN_ORIENTATIONS = ['landscape', 'portrait'];

var COMPONENT_ALTERNATIVE_COLORS = exports.COMPONENT_ALTERNATIVE_COLORS = ['secondary', 'success', 'alert', 'warning'];
var COMPONENT_COLORS = exports.COMPONENT_COLORS = ['primary'].concat(COMPONENT_ALTERNATIVE_COLORS);

var CALLOUT_SIZES = exports.CALLOUT_SIZES = ['small', 'large'];
var COMPONENT_SIZES = exports.COMPONENT_SIZES = ['tiny'].concat(CALLOUT_SIZES);
var MODAL_SIZES = exports.MODAL_SIZES = [].concat((0, _toConsumableArray3.default)(COMPONENT_SIZES), ['full']);

var CENTER_POSITION = exports.CENTER_POSITION = 'center';
var OFF_CANVAS_POSITIONS = exports.OFF_CANVAS_POSITIONS = ['left', 'right'];
var TITLE_BAR_POSITIONS = exports.TITLE_BAR_POSITIONS = [].concat(OFF_CANVAS_POSITIONS);
var TOP_BAR_POSITIONS = exports.TOP_BAR_POSITIONS = [].concat(OFF_CANVAS_POSITIONS);
var OVERLAY_POSITIONS_INTERNAL = exports.OVERLAY_POSITIONS_INTERNAL = [].concat(OFF_CANVAS_POSITIONS, ['top']);
var OVERLAY_POSITIONS = exports.OVERLAY_POSITIONS = [].concat((0, _toConsumableArray3.default)(OVERLAY_POSITIONS_INTERNAL), ['bottom']);
var FLOAT_POSITIONS = exports.FLOAT_POSITIONS = [].concat(OFF_CANVAS_POSITIONS, [CENTER_POSITION]);
var TEXT_ALIGNMENTS = exports.TEXT_ALIGNMENTS = [].concat((0, _toConsumableArray3.default)(FLOAT_POSITIONS), ['justify']);
var MENU_ALIGNMENTS = exports.MENU_ALIGNMENTS = [].concat((0, _toConsumableArray3.default)(FLOAT_POSITIONS));
var FLEX_HORIZONTAL_ALIGNMENTS = exports.FLEX_HORIZONTAL_ALIGNMENTS = [].concat((0, _toConsumableArray3.default)(TEXT_ALIGNMENTS), ['spaced']);

var _FLEX_HORIZONTAL_ALIG = (0, _toArray3.default)(FLEX_HORIZONTAL_ALIGNMENTS);

var FLEX_HORIZONTAL_ALIGNMENTS_INTERNAL = _FLEX_HORIZONTAL_ALIG.slice(1);

exports.FLEX_HORIZONTAL_ALIGNMENTS_INTERNAL = FLEX_HORIZONTAL_ALIGNMENTS_INTERNAL;
var MEDIA_OBJECT_SECTION_ALIGNMENTS = exports.MEDIA_OBJECT_SECTION_ALIGNMENTS = ['middle', 'bottom'];
var FLEX_VERTICAL_ALIGNMENTS = exports.FLEX_VERTICAL_ALIGNMENTS = ['top'].concat(MEDIA_OBJECT_SECTION_ALIGNMENTS, ['stretch']);

var GRID_ROW_CLASS_NAMES = exports.GRID_ROW_CLASS_NAMES = {
  collapse: {
    basePropName: 'Collapse',
    range: false,
    skipSmall: false
  },
  uncollapse: {
    basePropName: 'Uncollapse',
    range: false,
    skipSmall: false
  },
  up: {
    basePropName: 'Up',
    range: true,
    rangeMin: 1,
    rangeMax: 8,
    skipSmall: false
  }
};
var GRID_COLUMN_CLASS_NAMES = exports.GRID_COLUMN_CLASS_NAMES = {
  '': {
    basePropName: '',
    range: true,
    rangeMin: 1,
    rangeMax: 12,
    skipSmall: false
  },
  offset: {
    basePropName: 'Offset',
    range: true,
    rangeMin: 0,
    rangeMax: 11,
    skipSmall: false
  },
  centered: {
    basePropName: 'Centered',
    range: false,
    skipSmall: false
  },
  uncentered: {
    basePropName: 'Uncentered',
    range: false,
    skipSmall: false
  },
  push: {
    basePropName: 'Push',
    range: true,
    rangeMin: 1,
    rangeMax: 11,
    skipSmall: false
  },
  pull: {
    basePropName: 'Pull',
    range: true,
    rangeMin: 1,
    rangeMax: 11,
    skipSmall: false
  }
};

var FLEX_CHILD_CLASS_NAMES = exports.FLEX_CHILD_CLASS_NAMES = {
  order: {
    basePropName: 'Order',
    range: true,
    rangeMin: 1,
    rangeMax: 6,
    skipSmall: false
  }
};
var FLEX_GRID_ROW_CLASS_NAMES = exports.FLEX_GRID_ROW_CLASS_NAMES = {
  unstack: {
    basePropName: 'Unstack',
    range: false,
    skipSmall: true
  },
  collapse: {
    basePropName: 'Collapse',
    range: false,
    skipSmall: false
  },
  uncollapse: {
    basePropName: 'Uncollapse',
    range: false,
    skipSmall: false
  },
  up: {
    basePropName: 'Up',
    range: true,
    rangeMin: 1,
    rangeMax: 8,
    skipSmall: false
  }
};
var FLEX_GRID_COLUMN_CLASS_NAMES = exports.FLEX_GRID_COLUMN_CLASS_NAMES = {
  '': {
    basePropName: '',
    range: true,
    rangeMin: 1,
    rangeMax: 12,
    skipSmall: false
  },
  expand: {
    basePropName: 'Expand',
    range: false,
    skipSmall: true
  },
  offset: {
    basePropName: 'Offset',
    range: true,
    rangeMin: 0,
    rangeMax: 11,
    skipSmall: false
  }
};