'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _elementType = require('react-prop-types/lib/elementType');

var _elementType2 = _interopRequireDefault(_elementType);

var _RootCloseWrapper = require('react-overlays/lib/RootCloseWrapper');

var _RootCloseWrapper2 = _interopRequireDefault(_RootCloseWrapper);

var _Overlay = require('react-overlays/lib/Overlay');

var _Overlay2 = _interopRequireDefault(_Overlay);

var _contains = require('dom-helpers/query/contains');

var _contains2 = _interopRequireDefault(_contains);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function mouseOverOut(event, callback) {
  var target = event.currentTarget;
  var related = event.relatedTarget || event.nativeEvent.toElement;

  if (!related || related !== target && !(0, _contains2.default)(target, related)) {
    return callback(event);
  }
}

var OverlayTrigger = function (_Component) {
  (0, _inherits3.default)(OverlayTrigger, _Component);

  function OverlayTrigger(props) {
    (0, _classCallCheck3.default)(this, OverlayTrigger);

    var _this = (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(OverlayTrigger).call(this, props));

    _this.setTargetRef = function (ref) {
      return _this._targetRef = ref;
    };

    _this.getTargetRefDOMNode = function () {
      return (0, _reactDom.findDOMNode)(_this._targetRef);
    };

    _this.handleShow = function () {
      return _this.setState({ show: true });
    };

    _this.handleHide = function () {
      if (!_this._clicked) {
        _this.setState({ show: false });
      }
    };

    _this.handleAnyClick = function () {
      var show = _this.state.show;


      if (show) {
        if (_this._clicked) {
          _this._clicked = false;
          _this.handleHide();
        } else {
          _this._clicked = true;
        }
      } else {
        _this._clicked = true;
        _this.handleShow();
      }
    };

    _this.handleRootClose = function () {
      var closeOnClickOutside = _this.props.closeOnClickOutside;


      if (closeOnClickOutside) {
        var now = new Date();
        var diff = now - _this._lastRootClose;

        _this._lastRootClose = now;

        if (_this._clicked && diff < 50) {
          _this.handleAnyClick();
        }
      }
    };

    _this.handleClick = function () {
      var _this$props = _this.props;
      var onClick = _this$props.onClick;
      var triggerClick = _this$props.triggerClick;


      if (triggerClick) {
        _this.handleAnyClick();

        if (onClick) {
          onClick.apply(undefined, arguments);
        }
      }
    };

    _this.handleBlur = function () {
      var _this$props2 = _this.props;
      var onBlur = _this$props2.onBlur;
      var triggerFocus = _this$props2.triggerFocus;


      if (triggerFocus) {
        _this.handleHide();

        if (onBlur) {
          onBlur.apply(undefined, arguments);
        }
      }
    };

    _this.handleFocus = function () {
      var _this$props3 = _this.props;
      var onFocus = _this$props3.onFocus;
      var triggerFocus = _this$props3.triggerFocus;


      if (triggerFocus) {
        _this.handleShow();

        if (onFocus) {
          onFocus.apply(undefined, arguments);
        }
      }
    };

    _this.handleMouseOut = function () {
      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      var _this$props4 = _this.props;
      var onMouseOut = _this$props4.onMouseOut;
      var triggerHover = _this$props4.triggerHover;


      if (triggerHover) {
        var event = args[0];


        mouseOverOut(event, function () {
          _this.handleHide();

          if (onMouseOut) {
            onMouseOut.apply(undefined, args);
          }
        });
      }
    };

    _this.handleMouseOver = function () {
      for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      var _this$props5 = _this.props;
      var onMouseOver = _this$props5.onMouseOver;
      var triggerHover = _this$props5.triggerHover;
      var event = args[0];


      if (triggerHover) {
        mouseOverOut(event, function () {
          _this.handleShow();

          if (onMouseOver) {
            onMouseOver.apply(undefined, args);
          }
        });
      }
    };

    _this.createOverlay = function () {
      var _this$props6 = _this.props;
      var overlay = _this$props6.overlay;
      var position = _this$props6.position;
      var transition = _this$props6.transition;
      var show = _this.state.show;


      return _react2.default.createElement(
        _Overlay2.default,
        {
          onHide: _this.handleRootClose,
          placement: position,
          rootClose: true,
          show: show,
          target: _this.getTargetRefDOMNode,
          transition: transition
        },
        overlay
      );
    };

    _this.renderOverlay = function () {
      return (0, _reactDom.unstable_renderSubtreeIntoContainer // eslint-disable-line camelcase
      )(_this, _this._overlay, _this._mountNode);
    };

    _this.state = {
      show: false
    };
    _this._clicked = false;
    _this._lastRootClose = new Date();
    return _this;
  }

  (0, _createClass3.default)(OverlayTrigger, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._mountNode = document.createElement('div');
      this.renderOverlay();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (this._mountNode) {
        this.renderOverlay();
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      (0, _reactDom.unmountComponentAtNode)(this._mountNode);
      this._mountNode = null;
    }
  }, {
    key: 'render',
    value: function render() {
      var children = this.props.children;
      var show = this.state.show;

      var childProps = {
        'aria-expanded': show,
        onBlur: this.handleBlur,
        onClick: this.handleClick,
        onFocus: this.handleFocus,
        onMouseOut: this.handleMouseOut,
        onMouseOver: this.handleMouseOver,
        ref: this.setTargetRef
      };
      var newChild = null;

      if ((0, _react.isValidElement)(children)) {
        newChild = (0, _react.cloneElement)(children, childProps);
      } else {
        newChild = _react2.default.createElement(
          'span',
          childProps,
          children
        );
      }

      this._overlay = this.createOverlay();

      return _react2.default.createElement(
        _RootCloseWrapper2.default,
        { noWrap: true, onRootClose: this.handleRootClose },
        newChild
      );
    }
  }]);
  return OverlayTrigger;
}(_react.Component);

OverlayTrigger.propTypes = {
  children: _react.PropTypes.node,
  closeOnClickOutside: _react.PropTypes.bool,
  onBlur: _react.PropTypes.func,
  onClick: _react.PropTypes.func,
  onFocus: _react.PropTypes.func,
  onMouseOut: _react.PropTypes.func,
  onMouseOver: _react.PropTypes.func,
  overlay: _react.PropTypes.node,
  position: _react.PropTypes.oneOf(_constants.OVERLAY_POSITIONS),
  transition: _elementType2.default,
  triggerClick: _react.PropTypes.bool,
  triggerFocus: _react.PropTypes.bool,
  triggerHover: _react.PropTypes.bool
};
exports.default = OverlayTrigger;